//------------------------------------------------------------------------------
// PySyntaxBindings3.cpp
// Generated Python bindings for syntax types
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#include "pyslang.h"

#include "slang/syntax/AllSyntax.h"

void registerSyntaxNodes3(py::module_& m) {
    py::class_<ConstraintDeclarationSyntax, MemberSyntax>(m, "ConstraintDeclarationSyntax")
        .def_readwrite("qualifiers", &ConstraintDeclarationSyntax::qualifiers)
        .def_readwrite("keyword", &ConstraintDeclarationSyntax::keyword)
        .def_readwrite("specifiers", &ConstraintDeclarationSyntax::specifiers)
        .def_readwrite("name", &ConstraintDeclarationSyntax::name)
        .def_readwrite("block", &ConstraintDeclarationSyntax::block);

    py::class_<ParenExpressionListSyntax, SyntaxNode>(m, "ParenExpressionListSyntax")
        .def_readwrite("openParen", &ParenExpressionListSyntax::openParen)
        .def_readwrite("expressions", &ParenExpressionListSyntax::expressions)
        .def_readwrite("closeParen", &ParenExpressionListSyntax::closeParen);

    py::class_<ArrayOrRandomizeMethodExpressionSyntax, ExpressionSyntax>(m, "ArrayOrRandomizeMethodExpressionSyntax")
        .def_readwrite("method", &ArrayOrRandomizeMethodExpressionSyntax::method)
        .def_readwrite("with_", &ArrayOrRandomizeMethodExpressionSyntax::with)
        .def_readwrite("args", &ArrayOrRandomizeMethodExpressionSyntax::args)
        .def_readwrite("constraints", &ArrayOrRandomizeMethodExpressionSyntax::constraints);

    py::class_<WithFunctionSampleSyntax, SyntaxNode>(m, "WithFunctionSampleSyntax")
        .def_readwrite("with_", &WithFunctionSampleSyntax::with)
        .def_readwrite("function", &WithFunctionSampleSyntax::function)
        .def_readwrite("sample", &WithFunctionSampleSyntax::sample)
        .def_readwrite("portList", &WithFunctionSampleSyntax::portList);

    py::class_<BlockEventExpressionSyntax, SyntaxNode>(m, "BlockEventExpressionSyntax");

    py::class_<BinaryBlockEventExpressionSyntax, BlockEventExpressionSyntax>(m, "BinaryBlockEventExpressionSyntax")
        .def_readwrite("left", &BinaryBlockEventExpressionSyntax::left)
        .def_readwrite("orKeyword", &BinaryBlockEventExpressionSyntax::orKeyword)
        .def_readwrite("right", &BinaryBlockEventExpressionSyntax::right);

    py::class_<PrimaryBlockEventExpressionSyntax, BlockEventExpressionSyntax>(m, "PrimaryBlockEventExpressionSyntax")
        .def_readwrite("keyword", &PrimaryBlockEventExpressionSyntax::keyword)
        .def_readwrite("name", &PrimaryBlockEventExpressionSyntax::name);

    py::class_<BlockCoverageEventSyntax, SyntaxNode>(m, "BlockCoverageEventSyntax")
        .def_readwrite("atat", &BlockCoverageEventSyntax::atat)
        .def_readwrite("openParen", &BlockCoverageEventSyntax::openParen)
        .def_readwrite("expr", &BlockCoverageEventSyntax::expr)
        .def_readwrite("closeParen", &BlockCoverageEventSyntax::closeParen);

    py::class_<CovergroupDeclarationSyntax, MemberSyntax>(m, "CovergroupDeclarationSyntax")
        .def_readwrite("covergroup", &CovergroupDeclarationSyntax::covergroup)
        .def_readwrite("extends", &CovergroupDeclarationSyntax::extends)
        .def_readwrite("name", &CovergroupDeclarationSyntax::name)
        .def_readwrite("portList", &CovergroupDeclarationSyntax::portList)
        .def_readwrite("event", &CovergroupDeclarationSyntax::event)
        .def_readwrite("semi", &CovergroupDeclarationSyntax::semi)
        .def_readwrite("members", &CovergroupDeclarationSyntax::members)
        .def_readwrite("endgroup", &CovergroupDeclarationSyntax::endgroup)
        .def_readwrite("endBlockName", &CovergroupDeclarationSyntax::endBlockName);

    py::class_<CoverageOptionSyntax, MemberSyntax>(m, "CoverageOptionSyntax")
        .def_readwrite("expr", &CoverageOptionSyntax::expr)
        .def_readwrite("semi", &CoverageOptionSyntax::semi);

    py::class_<CoverageIffClauseSyntax, SyntaxNode>(m, "CoverageIffClauseSyntax")
        .def_readwrite("iff", &CoverageIffClauseSyntax::iff)
        .def_readwrite("openParen", &CoverageIffClauseSyntax::openParen)
        .def_readwrite("expr", &CoverageIffClauseSyntax::expr)
        .def_readwrite("closeParen", &CoverageIffClauseSyntax::closeParen);

    py::class_<CoverpointSyntax, MemberSyntax>(m, "CoverpointSyntax")
        .def_readwrite("type", &CoverpointSyntax::type)
        .def_readwrite("label", &CoverpointSyntax::label)
        .def_readwrite("coverpoint", &CoverpointSyntax::coverpoint)
        .def_readwrite("expr", &CoverpointSyntax::expr)
        .def_readwrite("iff", &CoverpointSyntax::iff)
        .def_readwrite("openBrace", &CoverpointSyntax::openBrace)
        .def_readwrite("members", &CoverpointSyntax::members)
        .def_readwrite("closeBrace", &CoverpointSyntax::closeBrace)
        .def_readwrite("emptySemi", &CoverpointSyntax::emptySemi);

    py::class_<CoverageBinInitializerSyntax, SyntaxNode>(m, "CoverageBinInitializerSyntax");

    py::class_<DefaultCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "DefaultCoverageBinInitializerSyntax")
        .def_readwrite("defaultKeyword", &DefaultCoverageBinInitializerSyntax::defaultKeyword)
        .def_readwrite("sequenceKeyword", &DefaultCoverageBinInitializerSyntax::sequenceKeyword);

    py::class_<WithClauseSyntax, SyntaxNode>(m, "WithClauseSyntax")
        .def_readwrite("with_", &WithClauseSyntax::with)
        .def_readwrite("openParen", &WithClauseSyntax::openParen)
        .def_readwrite("expr", &WithClauseSyntax::expr)
        .def_readwrite("closeParen", &WithClauseSyntax::closeParen);

    py::class_<ExpressionCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "ExpressionCoverageBinInitializerSyntax")
        .def_readwrite("expr", &ExpressionCoverageBinInitializerSyntax::expr);

    py::class_<RangeCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "RangeCoverageBinInitializerSyntax")
        .def_readwrite("ranges", &RangeCoverageBinInitializerSyntax::ranges)
        .def_readwrite("withClause", &RangeCoverageBinInitializerSyntax::withClause);

    py::class_<IdWithExprCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "IdWithExprCoverageBinInitializerSyntax")
        .def_readwrite("id", &IdWithExprCoverageBinInitializerSyntax::id)
        .def_readwrite("withClause", &IdWithExprCoverageBinInitializerSyntax::withClause);

    py::class_<TransRepeatRangeSyntax, SyntaxNode>(m, "TransRepeatRangeSyntax")
        .def_readwrite("openBracket", &TransRepeatRangeSyntax::openBracket)
        .def_readwrite("specifier", &TransRepeatRangeSyntax::specifier)
        .def_readwrite("selector", &TransRepeatRangeSyntax::selector)
        .def_readwrite("closeBracket", &TransRepeatRangeSyntax::closeBracket);

    py::class_<TransRangeSyntax, SyntaxNode>(m, "TransRangeSyntax")
        .def_readwrite("items", &TransRangeSyntax::items)
        .def_readwrite("repeat", &TransRangeSyntax::repeat);

    py::class_<TransSetSyntax, SyntaxNode>(m, "TransSetSyntax")
        .def_readwrite("openParen", &TransSetSyntax::openParen)
        .def_readwrite("ranges", &TransSetSyntax::ranges)
        .def_readwrite("closeParen", &TransSetSyntax::closeParen);

    py::class_<TransListCoverageBinInitializerSyntax, CoverageBinInitializerSyntax>(m, "TransListCoverageBinInitializerSyntax")
        .def_readwrite("sets", &TransListCoverageBinInitializerSyntax::sets);

    py::class_<CoverageBinsArraySizeSyntax, SyntaxNode>(m, "CoverageBinsArraySizeSyntax")
        .def_readwrite("openBracket", &CoverageBinsArraySizeSyntax::openBracket)
        .def_readwrite("expr", &CoverageBinsArraySizeSyntax::expr)
        .def_readwrite("closeBracket", &CoverageBinsArraySizeSyntax::closeBracket);

    py::class_<CoverageBinsSyntax, MemberSyntax>(m, "CoverageBinsSyntax")
        .def_readwrite("wildcard", &CoverageBinsSyntax::wildcard)
        .def_readwrite("keyword", &CoverageBinsSyntax::keyword)
        .def_readwrite("name", &CoverageBinsSyntax::name)
        .def_readwrite("size", &CoverageBinsSyntax::size)
        .def_readwrite("equals", &CoverageBinsSyntax::equals)
        .def_readwrite("initializer", &CoverageBinsSyntax::initializer)
        .def_readwrite("iff", &CoverageBinsSyntax::iff)
        .def_readwrite("semi", &CoverageBinsSyntax::semi);

    py::class_<CoverCrossSyntax, MemberSyntax>(m, "CoverCrossSyntax")
        .def_readwrite("label", &CoverCrossSyntax::label)
        .def_readwrite("cross", &CoverCrossSyntax::cross)
        .def_readwrite("items", &CoverCrossSyntax::items)
        .def_readwrite("iff", &CoverCrossSyntax::iff)
        .def_readwrite("openBrace", &CoverCrossSyntax::openBrace)
        .def_readwrite("members", &CoverCrossSyntax::members)
        .def_readwrite("closeBrace", &CoverCrossSyntax::closeBrace)
        .def_readwrite("emptySemi", &CoverCrossSyntax::emptySemi);

    py::class_<BinsSelectExpressionSyntax, SyntaxNode>(m, "BinsSelectExpressionSyntax");

    py::class_<IntersectClauseSyntax, SyntaxNode>(m, "IntersectClauseSyntax")
        .def_readwrite("intersect", &IntersectClauseSyntax::intersect)
        .def_readwrite("ranges", &IntersectClauseSyntax::ranges);

    py::class_<BinsSelectConditionExprSyntax, BinsSelectExpressionSyntax>(m, "BinsSelectConditionExprSyntax")
        .def_readwrite("binsof", &BinsSelectConditionExprSyntax::binsof)
        .def_readwrite("openParen", &BinsSelectConditionExprSyntax::openParen)
        .def_readwrite("name", &BinsSelectConditionExprSyntax::name)
        .def_readwrite("closeParen", &BinsSelectConditionExprSyntax::closeParen)
        .def_readwrite("intersects", &BinsSelectConditionExprSyntax::intersects);

    py::class_<UnaryBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "UnaryBinsSelectExprSyntax")
        .def_readwrite("op", &UnaryBinsSelectExprSyntax::op)
        .def_readwrite("expr", &UnaryBinsSelectExprSyntax::expr);

    py::class_<BinaryBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "BinaryBinsSelectExprSyntax")
        .def_readwrite("left", &BinaryBinsSelectExprSyntax::left)
        .def_readwrite("op", &BinaryBinsSelectExprSyntax::op)
        .def_readwrite("right", &BinaryBinsSelectExprSyntax::right);

    py::class_<ParenthesizedBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "ParenthesizedBinsSelectExprSyntax")
        .def_readwrite("openParen", &ParenthesizedBinsSelectExprSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedBinsSelectExprSyntax::expr)
        .def_readwrite("closeParen", &ParenthesizedBinsSelectExprSyntax::closeParen);

    py::class_<SimpleBinsSelectExprSyntax, BinsSelectExpressionSyntax>(m, "SimpleBinsSelectExprSyntax")
        .def_readwrite("expr", &SimpleBinsSelectExprSyntax::expr)
        .def_readwrite("matchesClause", &SimpleBinsSelectExprSyntax::matchesClause);

    py::class_<BinSelectWithFilterExprSyntax, BinsSelectExpressionSyntax>(m, "BinSelectWithFilterExprSyntax")
        .def_readwrite("expr", &BinSelectWithFilterExprSyntax::expr)
        .def_readwrite("with_", &BinSelectWithFilterExprSyntax::with)
        .def_readwrite("openParen", &BinSelectWithFilterExprSyntax::openParen)
        .def_readwrite("filter", &BinSelectWithFilterExprSyntax::filter)
        .def_readwrite("closeParen", &BinSelectWithFilterExprSyntax::closeParen)
        .def_readwrite("matchesClause", &BinSelectWithFilterExprSyntax::matchesClause);

    py::class_<BinsSelectionSyntax, MemberSyntax>(m, "BinsSelectionSyntax")
        .def_readwrite("keyword", &BinsSelectionSyntax::keyword)
        .def_readwrite("name", &BinsSelectionSyntax::name)
        .def_readwrite("equals", &BinsSelectionSyntax::equals)
        .def_readwrite("expr", &BinsSelectionSyntax::expr)
        .def_readwrite("iff", &BinsSelectionSyntax::iff)
        .def_readwrite("semi", &BinsSelectionSyntax::semi);

    py::class_<SequenceRepetitionSyntax, SyntaxNode>(m, "SequenceRepetitionSyntax")
        .def_readwrite("openBracket", &SequenceRepetitionSyntax::openBracket)
        .def_readwrite("op", &SequenceRepetitionSyntax::op)
        .def_readwrite("selector", &SequenceRepetitionSyntax::selector)
        .def_readwrite("closeBracket", &SequenceRepetitionSyntax::closeBracket);

    py::class_<SimpleSequenceExprSyntax, SequenceExprSyntax>(m, "SimpleSequenceExprSyntax")
        .def_readwrite("expr", &SimpleSequenceExprSyntax::expr)
        .def_readwrite("repetition", &SimpleSequenceExprSyntax::repetition);

    py::class_<SequenceMatchListSyntax, SyntaxNode>(m, "SequenceMatchListSyntax")
        .def_readwrite("comma", &SequenceMatchListSyntax::comma)
        .def_readwrite("items", &SequenceMatchListSyntax::items);

    py::class_<ParenthesizedSequenceExprSyntax, SequenceExprSyntax>(m, "ParenthesizedSequenceExprSyntax")
        .def_readwrite("openParen", &ParenthesizedSequenceExprSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedSequenceExprSyntax::expr)
        .def_readwrite("matchList", &ParenthesizedSequenceExprSyntax::matchList)
        .def_readwrite("closeParen", &ParenthesizedSequenceExprSyntax::closeParen)
        .def_readwrite("repetition", &ParenthesizedSequenceExprSyntax::repetition);

    py::class_<BinarySequenceExprSyntax, SequenceExprSyntax>(m, "BinarySequenceExprSyntax")
        .def_readwrite("left", &BinarySequenceExprSyntax::left)
        .def_readwrite("op", &BinarySequenceExprSyntax::op)
        .def_readwrite("right", &BinarySequenceExprSyntax::right);

    py::class_<FirstMatchSequenceExprSyntax, SequenceExprSyntax>(m, "FirstMatchSequenceExprSyntax")
        .def_readwrite("first_match", &FirstMatchSequenceExprSyntax::first_match)
        .def_readwrite("openParen", &FirstMatchSequenceExprSyntax::openParen)
        .def_readwrite("expr", &FirstMatchSequenceExprSyntax::expr)
        .def_readwrite("matchList", &FirstMatchSequenceExprSyntax::matchList)
        .def_readwrite("closeParen", &FirstMatchSequenceExprSyntax::closeParen);

    py::class_<ClockingSequenceExprSyntax, SequenceExprSyntax>(m, "ClockingSequenceExprSyntax")
        .def_readwrite("event", &ClockingSequenceExprSyntax::event)
        .def_readwrite("expr", &ClockingSequenceExprSyntax::expr);

    py::class_<DelayedSequenceElementSyntax, SyntaxNode>(m, "DelayedSequenceElementSyntax")
        .def_readwrite("doubleHash", &DelayedSequenceElementSyntax::doubleHash)
        .def_readwrite("delayVal", &DelayedSequenceElementSyntax::delayVal)
        .def_readwrite("openBracket", &DelayedSequenceElementSyntax::openBracket)
        .def_readwrite("op", &DelayedSequenceElementSyntax::op)
        .def_readwrite("range", &DelayedSequenceElementSyntax::range)
        .def_readwrite("closeBracket", &DelayedSequenceElementSyntax::closeBracket)
        .def_readwrite("expr", &DelayedSequenceElementSyntax::expr);

    py::class_<DelayedSequenceExprSyntax, SequenceExprSyntax>(m, "DelayedSequenceExprSyntax")
        .def_readwrite("first", &DelayedSequenceExprSyntax::first)
        .def_readwrite("elements", &DelayedSequenceExprSyntax::elements);

    py::class_<SimplePropertyExprSyntax, PropertyExprSyntax>(m, "SimplePropertyExprSyntax")
        .def_readwrite("expr", &SimplePropertyExprSyntax::expr);

    py::class_<ParenthesizedPropertyExprSyntax, PropertyExprSyntax>(m, "ParenthesizedPropertyExprSyntax")
        .def_readwrite("openParen", &ParenthesizedPropertyExprSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedPropertyExprSyntax::expr)
        .def_readwrite("matchList", &ParenthesizedPropertyExprSyntax::matchList)
        .def_readwrite("closeParen", &ParenthesizedPropertyExprSyntax::closeParen);

    py::class_<StrongWeakPropertyExprSyntax, PropertyExprSyntax>(m, "StrongWeakPropertyExprSyntax")
        .def_readwrite("keyword", &StrongWeakPropertyExprSyntax::keyword)
        .def_readwrite("openParen", &StrongWeakPropertyExprSyntax::openParen)
        .def_readwrite("expr", &StrongWeakPropertyExprSyntax::expr)
        .def_readwrite("closeParen", &StrongWeakPropertyExprSyntax::closeParen);

    py::class_<UnaryPropertyExprSyntax, PropertyExprSyntax>(m, "UnaryPropertyExprSyntax")
        .def_readwrite("op", &UnaryPropertyExprSyntax::op)
        .def_readwrite("expr", &UnaryPropertyExprSyntax::expr);

    py::class_<UnarySelectPropertyExprSyntax, PropertyExprSyntax>(m, "UnarySelectPropertyExprSyntax")
        .def_readwrite("op", &UnarySelectPropertyExprSyntax::op)
        .def_readwrite("openBracket", &UnarySelectPropertyExprSyntax::openBracket)
        .def_readwrite("selector", &UnarySelectPropertyExprSyntax::selector)
        .def_readwrite("closeBracket", &UnarySelectPropertyExprSyntax::closeBracket)
        .def_readwrite("expr", &UnarySelectPropertyExprSyntax::expr);

    py::class_<BinaryPropertyExprSyntax, PropertyExprSyntax>(m, "BinaryPropertyExprSyntax")
        .def_readwrite("left", &BinaryPropertyExprSyntax::left)
        .def_readwrite("op", &BinaryPropertyExprSyntax::op)
        .def_readwrite("right", &BinaryPropertyExprSyntax::right);

    py::class_<ClockingPropertyExprSyntax, PropertyExprSyntax>(m, "ClockingPropertyExprSyntax")
        .def_readwrite("event", &ClockingPropertyExprSyntax::event)
        .def_readwrite("expr", &ClockingPropertyExprSyntax::expr);

    py::class_<AcceptOnPropertyExprSyntax, PropertyExprSyntax>(m, "AcceptOnPropertyExprSyntax")
        .def_readwrite("keyword", &AcceptOnPropertyExprSyntax::keyword)
        .def_readwrite("openParen", &AcceptOnPropertyExprSyntax::openParen)
        .def_readwrite("condition", &AcceptOnPropertyExprSyntax::condition)
        .def_readwrite("closeParen", &AcceptOnPropertyExprSyntax::closeParen)
        .def_readwrite("expr", &AcceptOnPropertyExprSyntax::expr);

    py::class_<ElsePropertyClauseSyntax, SyntaxNode>(m, "ElsePropertyClauseSyntax")
        .def_readwrite("elseKeyword", &ElsePropertyClauseSyntax::elseKeyword)
        .def_readwrite("expr", &ElsePropertyClauseSyntax::expr);

    py::class_<ConditionalPropertyExprSyntax, PropertyExprSyntax>(m, "ConditionalPropertyExprSyntax")
        .def_readwrite("ifKeyword", &ConditionalPropertyExprSyntax::ifKeyword)
        .def_readwrite("openParen", &ConditionalPropertyExprSyntax::openParen)
        .def_readwrite("condition", &ConditionalPropertyExprSyntax::condition)
        .def_readwrite("closeParen", &ConditionalPropertyExprSyntax::closeParen)
        .def_readwrite("expr", &ConditionalPropertyExprSyntax::expr)
        .def_readwrite("elseClause", &ConditionalPropertyExprSyntax::elseClause);

    py::class_<PropertyCaseItemSyntax, SyntaxNode>(m, "PropertyCaseItemSyntax");

    py::class_<DefaultPropertyCaseItemSyntax, PropertyCaseItemSyntax>(m, "DefaultPropertyCaseItemSyntax")
        .def_readwrite("defaultKeyword", &DefaultPropertyCaseItemSyntax::defaultKeyword)
        .def_readwrite("colon", &DefaultPropertyCaseItemSyntax::colon)
        .def_readwrite("expr", &DefaultPropertyCaseItemSyntax::expr)
        .def_readwrite("semi", &DefaultPropertyCaseItemSyntax::semi);

    py::class_<StandardPropertyCaseItemSyntax, PropertyCaseItemSyntax>(m, "StandardPropertyCaseItemSyntax")
        .def_readwrite("expressions", &StandardPropertyCaseItemSyntax::expressions)
        .def_readwrite("colon", &StandardPropertyCaseItemSyntax::colon)
        .def_readwrite("expr", &StandardPropertyCaseItemSyntax::expr)
        .def_readwrite("semi", &StandardPropertyCaseItemSyntax::semi);

    py::class_<CasePropertyExprSyntax, PropertyExprSyntax>(m, "CasePropertyExprSyntax")
        .def_readwrite("caseKeyword", &CasePropertyExprSyntax::caseKeyword)
        .def_readwrite("openParen", &CasePropertyExprSyntax::openParen)
        .def_readwrite("expr", &CasePropertyExprSyntax::expr)
        .def_readwrite("closeParen", &CasePropertyExprSyntax::closeParen)
        .def_readwrite("items", &CasePropertyExprSyntax::items)
        .def_readwrite("endcase", &CasePropertyExprSyntax::endcase);

    py::class_<LocalVariableDeclarationSyntax, MemberSyntax>(m, "LocalVariableDeclarationSyntax")
        .def_readwrite("var", &LocalVariableDeclarationSyntax::var)
        .def_readwrite("type", &LocalVariableDeclarationSyntax::type)
        .def_readwrite("declarators", &LocalVariableDeclarationSyntax::declarators)
        .def_readwrite("semi", &LocalVariableDeclarationSyntax::semi);

    py::class_<PropertyDeclarationSyntax, MemberSyntax>(m, "PropertyDeclarationSyntax")
        .def_readwrite("keyword", &PropertyDeclarationSyntax::keyword)
        .def_readwrite("name", &PropertyDeclarationSyntax::name)
        .def_readwrite("portList", &PropertyDeclarationSyntax::portList)
        .def_readwrite("semi", &PropertyDeclarationSyntax::semi)
        .def_readwrite("variables", &PropertyDeclarationSyntax::variables)
        .def_readwrite("propertySpec", &PropertyDeclarationSyntax::propertySpec)
        .def_readwrite("optionalSemi", &PropertyDeclarationSyntax::optionalSemi)
        .def_readwrite("end", &PropertyDeclarationSyntax::end)
        .def_readwrite("endBlockName", &PropertyDeclarationSyntax::endBlockName);

    py::class_<SequenceDeclarationSyntax, MemberSyntax>(m, "SequenceDeclarationSyntax")
        .def_readwrite("keyword", &SequenceDeclarationSyntax::keyword)
        .def_readwrite("name", &SequenceDeclarationSyntax::name)
        .def_readwrite("portList", &SequenceDeclarationSyntax::portList)
        .def_readwrite("semi", &SequenceDeclarationSyntax::semi)
        .def_readwrite("variables", &SequenceDeclarationSyntax::variables)
        .def_readwrite("seqExpr", &SequenceDeclarationSyntax::seqExpr)
        .def_readwrite("optionalSemi", &SequenceDeclarationSyntax::optionalSemi)
        .def_readwrite("end", &SequenceDeclarationSyntax::end)
        .def_readwrite("endBlockName", &SequenceDeclarationSyntax::endBlockName);

    py::class_<CheckerDeclarationSyntax, MemberSyntax>(m, "CheckerDeclarationSyntax")
        .def_readwrite("keyword", &CheckerDeclarationSyntax::keyword)
        .def_readwrite("name", &CheckerDeclarationSyntax::name)
        .def_readwrite("portList", &CheckerDeclarationSyntax::portList)
        .def_readwrite("semi", &CheckerDeclarationSyntax::semi)
        .def_readwrite("members", &CheckerDeclarationSyntax::members)
        .def_readwrite("end", &CheckerDeclarationSyntax::end)
        .def_readwrite("endBlockName", &CheckerDeclarationSyntax::endBlockName);

    py::class_<CheckerDataDeclarationSyntax, MemberSyntax>(m, "CheckerDataDeclarationSyntax")
        .def_readwrite("rand", &CheckerDataDeclarationSyntax::rand)
        .def_readwrite("data", &CheckerDataDeclarationSyntax::data);

    py::class_<CompilationUnitSyntax, SyntaxNode>(m, "CompilationUnitSyntax")
        .def_readwrite("members", &CompilationUnitSyntax::members)
        .def_readwrite("endOfFile", &CompilationUnitSyntax::endOfFile);

    py::class_<LibraryMapSyntax, SyntaxNode>(m, "LibraryMapSyntax")
        .def_readwrite("members", &LibraryMapSyntax::members)
        .def_readwrite("endOfFile", &LibraryMapSyntax::endOfFile);

    py::class_<DirectiveSyntax, SyntaxNode>(m, "DirectiveSyntax")
        .def_readwrite("directive", &DirectiveSyntax::directive);

    py::class_<SimpleDirectiveSyntax, DirectiveSyntax>(m, "SimpleDirectiveSyntax");

    py::class_<IncludeDirectiveSyntax, DirectiveSyntax>(m, "IncludeDirectiveSyntax")
        .def_readwrite("fileName", &IncludeDirectiveSyntax::fileName);

    py::class_<ConditionalDirectiveExpressionSyntax, SyntaxNode>(m, "ConditionalDirectiveExpressionSyntax");

    py::class_<NamedConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "NamedConditionalDirectiveExpressionSyntax")
        .def_readwrite("name", &NamedConditionalDirectiveExpressionSyntax::name);

    py::class_<UnaryConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "UnaryConditionalDirectiveExpressionSyntax")
        .def_readwrite("op", &UnaryConditionalDirectiveExpressionSyntax::op)
        .def_readwrite("operand", &UnaryConditionalDirectiveExpressionSyntax::operand);

    py::class_<BinaryConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "BinaryConditionalDirectiveExpressionSyntax")
        .def_readwrite("left", &BinaryConditionalDirectiveExpressionSyntax::left)
        .def_readwrite("op", &BinaryConditionalDirectiveExpressionSyntax::op)
        .def_readwrite("right", &BinaryConditionalDirectiveExpressionSyntax::right);

    py::class_<ParenthesizedConditionalDirectiveExpressionSyntax, ConditionalDirectiveExpressionSyntax>(m, "ParenthesizedConditionalDirectiveExpressionSyntax")
        .def_readwrite("openParen", &ParenthesizedConditionalDirectiveExpressionSyntax::openParen)
        .def_readwrite("operand", &ParenthesizedConditionalDirectiveExpressionSyntax::operand)
        .def_readwrite("closeParen", &ParenthesizedConditionalDirectiveExpressionSyntax::closeParen);

    py::class_<ConditionalBranchDirectiveSyntax, DirectiveSyntax>(m, "ConditionalBranchDirectiveSyntax")
        .def_readwrite("expr", &ConditionalBranchDirectiveSyntax::expr)
        .def_readwrite("disabledTokens", &ConditionalBranchDirectiveSyntax::disabledTokens);

    py::class_<UnconditionalBranchDirectiveSyntax, DirectiveSyntax>(m, "UnconditionalBranchDirectiveSyntax")
        .def_readwrite("disabledTokens", &UnconditionalBranchDirectiveSyntax::disabledTokens);

    py::class_<MacroArgumentDefaultSyntax, SyntaxNode>(m, "MacroArgumentDefaultSyntax")
        .def_readwrite("equals", &MacroArgumentDefaultSyntax::equals)
        .def_readwrite("tokens", &MacroArgumentDefaultSyntax::tokens);

    py::class_<MacroFormalArgumentSyntax, SyntaxNode>(m, "MacroFormalArgumentSyntax")
        .def_readwrite("name", &MacroFormalArgumentSyntax::name)
        .def_readwrite("defaultValue", &MacroFormalArgumentSyntax::defaultValue);

    py::class_<MacroFormalArgumentListSyntax, SyntaxNode>(m, "MacroFormalArgumentListSyntax")
        .def_readwrite("openParen", &MacroFormalArgumentListSyntax::openParen)
        .def_readwrite("args", &MacroFormalArgumentListSyntax::args)
        .def_readwrite("closeParen", &MacroFormalArgumentListSyntax::closeParen);

    py::class_<DefineDirectiveSyntax, DirectiveSyntax>(m, "DefineDirectiveSyntax")
        .def_readwrite("name", &DefineDirectiveSyntax::name)
        .def_readwrite("formalArguments", &DefineDirectiveSyntax::formalArguments)
        .def_readwrite("body", &DefineDirectiveSyntax::body);

    py::class_<MacroActualArgumentSyntax, SyntaxNode>(m, "MacroActualArgumentSyntax")
        .def_readwrite("tokens", &MacroActualArgumentSyntax::tokens);

    py::class_<MacroActualArgumentListSyntax, SyntaxNode>(m, "MacroActualArgumentListSyntax")
        .def_readwrite("openParen", &MacroActualArgumentListSyntax::openParen)
        .def_readwrite("args", &MacroActualArgumentListSyntax::args)
        .def_readwrite("closeParen", &MacroActualArgumentListSyntax::closeParen);

    py::class_<MacroUsageSyntax, DirectiveSyntax>(m, "MacroUsageSyntax")
        .def_readwrite("args", &MacroUsageSyntax::args);

    py::class_<TimeScaleDirectiveSyntax, DirectiveSyntax>(m, "TimeScaleDirectiveSyntax")
        .def_readwrite("timeUnit", &TimeScaleDirectiveSyntax::timeUnit)
        .def_readwrite("slash", &TimeScaleDirectiveSyntax::slash)
        .def_readwrite("timePrecision", &TimeScaleDirectiveSyntax::timePrecision);

    py::class_<DefaultNetTypeDirectiveSyntax, DirectiveSyntax>(m, "DefaultNetTypeDirectiveSyntax")
        .def_readwrite("netType", &DefaultNetTypeDirectiveSyntax::netType);

    py::class_<UnconnectedDriveDirectiveSyntax, DirectiveSyntax>(m, "UnconnectedDriveDirectiveSyntax")
        .def_readwrite("strength", &UnconnectedDriveDirectiveSyntax::strength);

    py::class_<DefaultDecayTimeDirectiveSyntax, DirectiveSyntax>(m, "DefaultDecayTimeDirectiveSyntax")
        .def_readwrite("time", &DefaultDecayTimeDirectiveSyntax::time);

    py::class_<DefaultTriregStrengthDirectiveSyntax, DirectiveSyntax>(m, "DefaultTriregStrengthDirectiveSyntax")
        .def_readwrite("strength", &DefaultTriregStrengthDirectiveSyntax::strength);

    py::class_<LineDirectiveSyntax, DirectiveSyntax>(m, "LineDirectiveSyntax")
        .def_readwrite("lineNumber", &LineDirectiveSyntax::lineNumber)
        .def_readwrite("fileName", &LineDirectiveSyntax::fileName)
        .def_readwrite("level", &LineDirectiveSyntax::level);

    py::class_<UndefDirectiveSyntax, DirectiveSyntax>(m, "UndefDirectiveSyntax")
        .def_readwrite("name", &UndefDirectiveSyntax::name);

    py::class_<BeginKeywordsDirectiveSyntax, DirectiveSyntax>(m, "BeginKeywordsDirectiveSyntax")
        .def_readwrite("versionSpecifier", &BeginKeywordsDirectiveSyntax::versionSpecifier);

    py::class_<PragmaExpressionSyntax, SyntaxNode>(m, "PragmaExpressionSyntax");

    py::class_<SimplePragmaExpressionSyntax, PragmaExpressionSyntax>(m, "SimplePragmaExpressionSyntax")
        .def_readwrite("value", &SimplePragmaExpressionSyntax::value);

    py::class_<NameValuePragmaExpressionSyntax, PragmaExpressionSyntax>(m, "NameValuePragmaExpressionSyntax")
        .def_readwrite("name", &NameValuePragmaExpressionSyntax::name)
        .def_readwrite("equals", &NameValuePragmaExpressionSyntax::equals)
        .def_readwrite("value", &NameValuePragmaExpressionSyntax::value);

    py::class_<NumberPragmaExpressionSyntax, PragmaExpressionSyntax>(m, "NumberPragmaExpressionSyntax")
        .def_readwrite("size", &NumberPragmaExpressionSyntax::size)
        .def_readwrite("base", &NumberPragmaExpressionSyntax::base)
        .def_readwrite("value", &NumberPragmaExpressionSyntax::value);

    py::class_<ParenPragmaExpressionSyntax, PragmaExpressionSyntax>(m, "ParenPragmaExpressionSyntax")
        .def_readwrite("openParen", &ParenPragmaExpressionSyntax::openParen)
        .def_readwrite("values", &ParenPragmaExpressionSyntax::values)
        .def_readwrite("closeParen", &ParenPragmaExpressionSyntax::closeParen);

    py::class_<PragmaDirectiveSyntax, DirectiveSyntax>(m, "PragmaDirectiveSyntax")
        .def_readwrite("name", &PragmaDirectiveSyntax::name)
        .def_readwrite("args", &PragmaDirectiveSyntax::args);

    py::class_<ConfigCellIdentifierSyntax, SyntaxNode>(m, "ConfigCellIdentifierSyntax")
        .def_readwrite("library", &ConfigCellIdentifierSyntax::library)
        .def_readwrite("dot", &ConfigCellIdentifierSyntax::dot)
        .def_readwrite("cell", &ConfigCellIdentifierSyntax::cell);

    py::class_<ConfigRuleClauseSyntax, SyntaxNode>(m, "ConfigRuleClauseSyntax");

    py::class_<ConfigLiblistSyntax, ConfigRuleClauseSyntax>(m, "ConfigLiblistSyntax")
        .def_readwrite("liblist", &ConfigLiblistSyntax::liblist)
        .def_readwrite("libraries", &ConfigLiblistSyntax::libraries);

    py::class_<ConfigUseClauseSyntax, ConfigRuleClauseSyntax>(m, "ConfigUseClauseSyntax")
        .def_readwrite("use", &ConfigUseClauseSyntax::use)
        .def_readwrite("name", &ConfigUseClauseSyntax::name)
        .def_readwrite("paramAssignments", &ConfigUseClauseSyntax::paramAssignments)
        .def_readwrite("colon", &ConfigUseClauseSyntax::colon)
        .def_readwrite("config", &ConfigUseClauseSyntax::config);

    py::class_<ConfigRuleSyntax, SyntaxNode>(m, "ConfigRuleSyntax");

    py::class_<DefaultConfigRuleSyntax, ConfigRuleSyntax>(m, "DefaultConfigRuleSyntax")
        .def_readwrite("defaultKeyword", &DefaultConfigRuleSyntax::defaultKeyword)
        .def_readwrite("liblist", &DefaultConfigRuleSyntax::liblist)
        .def_readwrite("semi", &DefaultConfigRuleSyntax::semi);

    py::class_<ConfigInstanceIdentifierSyntax, SyntaxNode>(m, "ConfigInstanceIdentifierSyntax")
        .def_readwrite("dot", &ConfigInstanceIdentifierSyntax::dot)
        .def_readwrite("name", &ConfigInstanceIdentifierSyntax::name);

    py::class_<InstanceConfigRuleSyntax, ConfigRuleSyntax>(m, "InstanceConfigRuleSyntax")
        .def_readwrite("instance", &InstanceConfigRuleSyntax::instance)
        .def_readwrite("topModule", &InstanceConfigRuleSyntax::topModule)
        .def_readwrite("instanceNames", &InstanceConfigRuleSyntax::instanceNames)
        .def_readwrite("ruleClause", &InstanceConfigRuleSyntax::ruleClause)
        .def_readwrite("semi", &InstanceConfigRuleSyntax::semi);

    py::class_<CellConfigRuleSyntax, ConfigRuleSyntax>(m, "CellConfigRuleSyntax")
        .def_readwrite("cell", &CellConfigRuleSyntax::cell)
        .def_readwrite("name", &CellConfigRuleSyntax::name)
        .def_readwrite("ruleClause", &CellConfigRuleSyntax::ruleClause)
        .def_readwrite("semi", &CellConfigRuleSyntax::semi);

    py::class_<ConfigDeclarationSyntax, MemberSyntax>(m, "ConfigDeclarationSyntax")
        .def_readwrite("config", &ConfigDeclarationSyntax::config)
        .def_readwrite("name", &ConfigDeclarationSyntax::name)
        .def_readwrite("semi1", &ConfigDeclarationSyntax::semi1)
        .def_readwrite("localparams", &ConfigDeclarationSyntax::localparams)
        .def_readwrite("design", &ConfigDeclarationSyntax::design)
        .def_readwrite("topCells", &ConfigDeclarationSyntax::topCells)
        .def_readwrite("semi2", &ConfigDeclarationSyntax::semi2)
        .def_readwrite("rules", &ConfigDeclarationSyntax::rules)
        .def_readwrite("endconfig", &ConfigDeclarationSyntax::endconfig)
        .def_readwrite("blockName", &ConfigDeclarationSyntax::blockName);

    py::class_<FilePathSpecSyntax, SyntaxNode>(m, "FilePathSpecSyntax")
        .def_readwrite("path", &FilePathSpecSyntax::path);

    py::class_<LibraryIncDirClauseSyntax, SyntaxNode>(m, "LibraryIncDirClauseSyntax")
        .def_readwrite("minus", &LibraryIncDirClauseSyntax::minus)
        .def_readwrite("incdir", &LibraryIncDirClauseSyntax::incdir)
        .def_readwrite("filePaths", &LibraryIncDirClauseSyntax::filePaths);

    py::class_<LibraryDeclarationSyntax, MemberSyntax>(m, "LibraryDeclarationSyntax")
        .def_readwrite("library", &LibraryDeclarationSyntax::library)
        .def_readwrite("name", &LibraryDeclarationSyntax::name)
        .def_readwrite("filePaths", &LibraryDeclarationSyntax::filePaths)
        .def_readwrite("incDirClause", &LibraryDeclarationSyntax::incDirClause)
        .def_readwrite("semi", &LibraryDeclarationSyntax::semi);

    py::class_<LibraryIncludeStatementSyntax, MemberSyntax>(m, "LibraryIncludeStatementSyntax")
        .def_readwrite("include", &LibraryIncludeStatementSyntax::include)
        .def_readwrite("filePath", &LibraryIncludeStatementSyntax::filePath)
        .def_readwrite("semi", &LibraryIncludeStatementSyntax::semi);

}
